#!/usr/bin/env python3
import socket
import sys

def extract_port(text):
    try:
        port = int(text)
        if port < 0 or port > 65535: return None
    except:
        return None

    return port

def main():
    args = sys.argv[1:]

    if len(args) == 0:
        print("USAGE: ./mitm.py SRC_PORT [DST_PORT [DST_ADDRESS]]")
        return 1

    if len(args) > 1:
        print("NOT IMPLEMENTED YET")  ## TODO: доделайте сами!
        return 2

    src_port = extract_port(args[0])
    if src_port == None:
        print("SRC_PORT must be in range 0 - 65535")
        return 2

    sock = socket.socket()
    sock.bind( ('', src_port) )
    sock.listen(0)
    
    while True:
        conn, addr = sock.accept()
        print("CONNECTION ESTABLISHED WITH", addr)
        print("LISTENING")

        while True:
            data = conn.recv(100500)
            if len(data) == 0: break
            print_data(data)

        print("CONNECTION CLOSED WITH", addr)


def to_hex(byte):  ## вместо этого обычно пользуются форматированием текстов
                   ## например, "%02x" % byte
    text = hex(byte)[2:]
    if len(text) == 1: return '0' + text
    return text


def print_data(data):
    col = 0
    row = []
    for byte in data:
        print(to_hex(byte), end = ' ')
        col += 1
        row.append(byte)
        if col == 16: 
            col = 0
            print(" | " + repr(str(bytes(row), 'utf-8'))[1:-1])
            row = []
    if col > 0:
        print(" | " + repr(str(bytes(row), 'utf-8'))[1:-1])
        # В качестве тривиального упражнения: перенести эту черту
        # в правильное место.
        #
        # В качестве нетривиального: если количество поступивших байт данных
        # не делится на количество колонок, отложить печать до поступления 
        # новых данных (не удивляйтесь, если Вы не увидите частично 
        # напечатанный текст: буфер печати опустошается обычно либо при
        # переходе на следующую строчку, либо при насильном его опустошении).


exit(main())

